#include <iostream.h>
struct coppia {
// contiene una coppia di indici di riga       
   unsigned int r1;
   unsigned int r2;
};

void leggimatrice(int * matrice, int r, int c);
bool cercasimili(int *m, int r, int c, coppia v[], int & riemp);

int main(){
     int r, c;
     cout << "Righe della matrice? ";
     cin >> r;
     cout << endl;
     cout << "Colonne della matrice? ";
     cin >> c;
     cout << endl;
     int matr[r][c];
     leggimatrice(&matr[0][0], r, c);

     for(int i=0; i<r; i++)
        {for(int j=0; j<c; j++)
           {cout <<matr[i][j]<<" ";}
         cout << endl;
        }

     coppia coppie[r];
     // vettore in cui memorizzeremo le coppie di righe simili che hanno il 
     // numero di valori uguali nelle stesse posizioni pi alto
     int riemp=0;
     // all'inizio coppie[] ha riempimento 0 perch  vuoto
     if (cercasimili(&matr[0][0], r, c, coppie, riemp))
       {cout << "Le coppie di righe pi simili sono:"<<endl;
        for (int i=0; i<riemp; i++)
        {cout << coppie[i].r1<<","<< coppie[i].r2<<endl;}
       }
     else
       {cout << "Non ci sono coppie di righe simili."<<endl;}
     system("PAUSE");
}

void leggimatrice(int * matrice, int r, int c){ 
     for (int i=0; i<r; i++)
        {for (int j=0; j<c; j++)
             {cout << "Inserisci l'elemento di posto (" << i << "," <<j<<"): ";
              cin >> *(matrice + i*c + j);
             }
        }
}
          
bool cercasimili(int *m, int r, int c, coppia v[], int & riemp){
    int maxnumsimilitudini=0;
    for (int i=0; i<r-1; i++)
    // confronta ogni riga tranne l'ultima
       for (int k=i+1; k<r; k++)
       // con tutte le successive
          {int conta=0;
           for (int j=0; j<c; j++)
           // conta quanti valori uguali hanno nella stessa posizione
             {if (*(m + i*c + j)== *(m + k*c + j))
                {conta++;}
             }
           if (conta>0)
             {if (conta>maxnumsimilitudini)
              // se ha trovato un numero di similitudini maggiore del massimo
              // trovato finora bisogna svuotare il vettore e aggiungere questa 
              // coppia di indici
                {riemp=1;
                 v[0].r1=i;
                 v[0].r2=k;
                 maxnumsimilitudini=conta;
                }
              else if (conta==maxnumsimilitudini)
              // invece se il numero di similitudini  il massimo trovato finora
              // bisogna aggiungere questa coppia di indici al vettore    
                {v[riemp].r1=i;
                 v[riemp].r2=k;
                 riemp++;
                }
             }
          }
    return (maxnumsimilitudini>0);
}
